ApprovalManagement

The APS type is used for Approval Engine related functionality.It handles Approval Requests, Approval Workflow related Rest APIs.

GraphViz

Schema

The considered APS type (download) extends the Resource APS type(s) and looks as follows:

{
  "name": "ApprovalManagement",
  "id": "http://com.odin.approvalengineapp/approvalmanagement/2.0",
  "apsVersion": "2.0",
  "implements": [
    "http://aps-standard.org/types/core/resource/1.0"
  ],
  "access": {
    "referrer": true,
    "global": false
  },
  "properties": {
    "seekApprovalTemplateId": {
      "type": "integer",
      "title": "seekApprovalTemplateId"
    },
    "remindApprovalTemplateId": {
      "type": "integer",
      "title": "remindApprovalTemplateId"
    },
    "approvalFulfilmentTemplateId": {
      "type": "integer",
      "title": "approvalFulfilmentTemplateId"
    }
  },
  "operations": {
    "getApprovalRequests": {
      "path": "/request",
      "verb": "GET",
      "response": {
        "type": "array",
        "items": {
          "type": "ApprovalRequestAccepted"
        }
      },
      "errorResponse": {
        "type": "object"
      },
      "access": {
        "public": false
      },
      "parameters": {
        "type": {
          "kind": "query",
          "type": "string"
        }
      }
    },
    "updateRequest": {
      "path": "/request",
      "verb": "PUT",
      "errorResponse": {
        "type": "object"
      },
      "access": {
        "referrer": true,
        "privilege": "http://www.ingrammicro.com/approvalengineapp#ae-manage-requests"
      },
      "parameters": {
        "request": {
          "kind": "body",
          "type": "array"
        }
      }
    },
    "submitForApproval": {
      "path": "/submitForApproval",
      "verb": "POST",
      "errorResponse": {
        "type": "object"
      },
      "access": {
        "public": false
      },
      "parameters": {
        "requestForApproval": {
          "kind": "body",
          "type": "RequestForApproval"
        }
      }
    },
    "getApprovalStepProgress": {
      "path": "/request/progress",
      "verb": "GET",
      "response": {
        "type": "array",
        "items": {
          "type": "ApprovalStepProgress"
        }
      },
      "errorResponse": {
        "type": "object"
      },
      "access": {
        "public": false
      },
      "parameters": {
        "requestId": {
          "kind": "query",
          "type": "string"
        }
      }
    },
    "getApprovalRequestDetails": {
      "path": "/request/{requestId}",
      "verb": "GET",
      "response": {
        "type": "ApprovalRequestAccepted"
      },
      "errorResponse": {
        "type": "object"
      },
      "access": {
        "public": false
      },
      "parameters": {
        "requestId": {
          "kind": "path",
          "type": "string"
        }
      }
    },
    "getRequestsDashboardInfo": {
      "path": "/request/dashboardInfo",
      "verb": "GET",
      "response": {
        "type": "DashboardInfo"
      },
      "errorResponse": {
        "type": "object"
      },
      "access": {
        "public": false
      }
    },
    "getWorkflowDetails": {
      "path": "/workflow",
      "verb": "GET",
      "errorResponse": {
        "type": "object"
      }
    },
    "saveWorkflow": {
      "path": "/workflow",
      "verb": "POST",
      "errorResponse": {
        "type": "object"
      },
      "access": {
        "referrer": true,
        "privilege": "http://www.ingrammicro.com/approvalengineapp#ae-manage-workflows"
      },
      "parameters": {
        "workflow": {
          "kind": "body",
          "type": "Workflow"
        }
      }
    },
    "updateWorkflow": {
      "path": "/workflow",
      "verb": "PUT",
      "errorResponse": {
        "type": "object"
      },
      "access": {
        "referrer": true,
        "privilege": "http://www.ingrammicro.com/approvalengineapp#ae-manage-workflows"
      },
      "parameters": {
        "workflow": {
          "kind": "body",
          "type": "Workflow"
        }
      }
    },
    "getWorkflow": {
      "path": "/workflow/{workflowUUID}",
      "verb": "GET",
      "errorResponse": {
        "type": "object"
      },
      "parameters": {
        "workflowUUID": {
          "kind": "path",
          "type": "string"
        }
      }
    },
    "deleteWorkflow": {
      "path": "/workflow/delete",
      "verb": "PUT",
      "errorResponse": {
        "type": "object"
      },
      "access": {
        "referrer": true,
        "privilege": "http://www.ingrammicro.com/approvalengineapp#ae-manage-workflows"
      },
      "parameters": {
        "workflowUUIDs": {
          "kind": "body",
          "type": "array"
        }
      }
    },
    "getCriteriaOperators": {
      "path": "/workflow/criteriaoperators",
      "verb": "GET",
      "response": {
        "type": "array",
        "items": {
          "type": "CriteriaOperators"
        }
      },
      "errorResponse": {
        "type": "object"
      },
      "access": {
        "public": false
      }
    },
    "getUsersByLoggedInUser": {
      "path": "/workflow/approvers",
      "verb": "GET",
      "response": {
        "type": "array",
        "items": {
          "type": "ApproverGroupUserDetails"
        }
      },
      "errorResponse": {
        "type": "object"
      },
      "access": {
        "public": false
      }
    }
  },
  "structures": {
    "RequestProperties": {
      "type": "object",
      "properties": {
        "description": {
          "type": "string",
          "title": "description"
        },
        "fields": {
          "type": "array",
          "title": "fields",
          "items": {
            "type": "EntityProperty"
          }
        }
      }
    },
    "EntityProperty": {
      "type": "object",
      "properties": {
        "name": {
          "type": "string",
          "title": "name"
        },
        "value": {
          "type": "string",
          "title": "value"
        },
        "number": {
          "type": "integer",
          "title": "number"
        },
        "description": {
          "type": "string",
          "title": "description"
        }
      }
    },
    "Status": {
      "type": "object",
      "properties": {
        "state": {
          "type": "string"
        },
        "statusId": {
          "type": "integer"
        }
      }
    },
    "ObjectProperty": {
      "type": "object",
      "properties": {
        "key": {
          "type": "string"
        },
        "value": {
          "type": "string"
        }
      }
    },
    "ApprovalStepProgress": {
      "type": "object",
      "properties": {
        "approvalObjectId": {
          "type": "string"
        },
        "approvalObjectName": {
          "type": "string"
        },
        "stepId": {
          "type": "integer"
        },
        "stepStatus": {
          "type": "string"
        },
        "stepStatusId": {
          "type": "integer"
        },
        "rank": {
          "type": "integer"
        },
        "approverUserName": {
          "type": "string"
        },
        "designatedApproverName": {
          "type": "string"
        },
        "approverUUIDs": {
          "type": "array",
          "items": {
            "type": "string"
          }
        },
        "reason": {
          "type": "string"
        },
        "approvalCriteriaList": {
          "type": "array",
          "items": {
            "type": "ApprovalCriteria"
          }
        },
        "creationDate": {
          "type": "string",
          "format": "date-time"
        },
        "lastEditDate": {
          "type": "string",
          "format": "date-time"
        },
        "timeOfAutoProcessing": {
          "type": "string",
          "format": "date-time"
        }
      }
    },
    "ApprovalCriteria": {
      "type": "object",
      "properties": {
        "criteriaName": {
          "type": "string"
        },
        "criteriaUUID": {
          "type": "string"
        },
        "criteriaHBID": {
          "type": "integer"
        },
        "criteriaDisplayName": {
          "type": "string"
        },
        "dataType": {
          "type": "string"
        },
        "operator": {
          "type": "string"
        },
        "operatorLabel": {
          "type": "string"
        },
        "value": {
          "type": "string"
        },
        "creationDate": {
          "type": "string",
          "format": "date-time"
        },
        "lastEditDate": {
          "type": "string",
          "format": "date-time"
        },
        "operatorSymbol": {
          "type": "string"
        }
      }
    },
    "ApprovalRequestAccepted": {
      "type": "object",
      "properties": {
        "requestId": {
          "type": "string"
        },
        "requestHBID": {
          "type": "integer"
        },
        "workflowId": {
          "type": "integer"
        },
        "stepId": {
          "type": "integer"
        },
        "performingApplication": {
          "type": "string"
        },
        "operationName": {
          "type": "string"
        },
        "parameters": {
          "type": "array",
          "items": {
            "type": "RequestProperties"
          }
        },
        "workflowUuid": {
          "type": "string"
        },
        "workflowDescription": {
          "type": "string"
        },
        "initiator": {
          "type": "string"
        },
        "initiatorId": {
          "type": "string"
        },
        "requestDate": {
          "type": "string",
          "format": "date-time"
        },
        "lastEditDate": {
          "type": "string",
          "format": "date-time"
        },
        "status": {
          "type": "Status"
        },
        "performBy": {
          "type": "string"
        },
        "reason": {
          "type": "string"
        },
        "id": {
          "type": "string"
        },
        "name": {
          "type": "string"
        },
        "isApprover": {
          "type": "boolean"
        },
        "objectProperties": {
          "type": "array",
          "items": {
            "type": "ObjectProperty"
          }
        },
        "approvalStepProgress": {
          "type": "array",
          "items": {
            "type": "ApprovalStepProgress"
          }
        },
        "applicationAPSPackageId": {
          "type": "string"
        }
      }
    },
    "ApprovalRequestContext": {
      "type": "object",
      "properties": {
        "requestId": {
          "type": "string"
        },
        "workflowId": {
          "type": "integer"
        },
        "stepId": {
          "type": "integer"
        },
        "UIAction": {
          "type": "string"
        },
        "reason": {
          "type": "string"
        },
        "performBy": {
          "type": "string"
        }
      }
    },
    "RequestInitiatorType": {
      "type": "object"
    },
    "RequestEntity": {
      "type": "object",
      "properties": {
        "id": {
          "type": "string",
          "title": "id"
        },
        "name": {
          "type": "string",
          "title": "name"
        },
        "fields": {
          "type": "array",
          "title": "fields",
          "items": {
            "type": "EntityProperty"
          }
        }
      }
    },
    "RequestForApproval": {
      "type": "object",
      "properties": {
        "performingApplication": {
          "type": "string",
          "title": "performingApplication"
        },
        "moduleAPSIdentifier": {
          "type": "string"
        },
        "actionName": {
          "type": "string",
          "title": "actionName"
        },
        "initiator": {
          "type": "string",
          "title": "initiator"
        },
        "initiatorType": {
          "type": "string",
          "title": "initiatorType",
          "enum": [
            "PROVIDER",
            "RESELLER",
            "CUSTOMER"
          ]
        },
        "entity": {
          "type": "RequestEntity",
          "title": "entity"
        }
      }
    },
    "DashboardInfo": {
      "type": "object",
      "properties": {
        "numRequestsWaitingMyApprove": {
          "type": "integer"
        },
        "timeOfNextAutohandling": {
          "type": "string",
          "format": "date-time"
        }
      }
    },
    "WorkflowDetails": {
      "type": "object",
      "properties": {
        "workflowUUID": {
          "type": "string"
        },
        "workflowHBID": {
          "type": "integer"
        },
        "description": {
          "type": "string"
        },
        "applicationName": {
          "type": "string"
        },
        "applicationAPSTypeId": {
          "type": "string"
        },
        "action": {
          "type": "string"
        },
        "creationDate": {
          "type": "string",
          "format": "date-time"
        },
        "lastEditDate": {
          "type": "string",
          "format": "date-time"
        },
        "ownerAccountId": {
          "type": "string"
        },
        "moduleAPSIdentifier": {
          "type": "string"
        },
        "actionBody": {
          "type": "ModuleAction"
        },
        "autoProcessThreshold": {
          "type": "integer"
        },
        "autoProcessAction": {
          "type": "AutoProcessAction"
        },
        "initiatorType": {
          "type": "RequestInitiatorType"
        },
        "isActive": {
          "type": "boolean"
        },
        "applicationAPSPackageId": {
          "type": "string"
        }
      }
    },
    "ModuleAction": {
      "type": "object",
      "properties": {
        "name": {
          "type": "string"
        },
        "entity": {
          "type": "ModuleActionEntity"
        }
      }
    },
    "ModuleActionEntity": {
      "type": "object",
      "properties": {
        "fields": {
          "type": "array",
          "title": "fields",
          "items": {
            "type": "TypedProperty"
          }
        }
      }
    },
    "TypedProperty": {
      "type": "object",
      "properties": {
        "name": {
          "type": "string",
          "title": "name"
        },
        "value": {
          "type": "string",
          "title": "value"
        },
        "displayName": {
          "type": "string",
          "title": "displayName"
        },
        "displayHint": {
          "type": "string",
          "title": "displayHint"
        },
        "type": {
          "type": "string",
          "title": "type"
        },
        "isArray": {
          "type": "boolean",
          "title": "isArray"
        },
        "isCriteria": {
          "type": "boolean",
          "title": "isCriteria"
        }
      }
    },
    "AutoProcessAction": {
      "type": "object"
    },
    "ApprovalStep": {
      "type": "object",
      "properties": {
        "stepUUID": {
          "type": "string"
        },
        "stepHBID": {
          "type": "integer"
        },
        "approvalCriteriaList": {
          "type": "array",
          "items": {
            "type": "ApprovalCriteria"
          }
        },
        "approverUserUUID": {
          "type": "string"
        },
        "approverUserName": {
          "type": "string"
        },
        "approverAccountUUID": {
          "type": "string"
        },
        "creationDate": {
          "type": "string",
          "format": "date-time"
        },
        "lastEditDate": {
          "type": "string",
          "format": "date-time"
        },
        "rank": {
          "type": "integer"
        }
      }
    },
    "Workflow": {
      "type": "object",
      "properties": {
        "workflowDetails": {
          "type": "WorkflowDetails"
        },
        "approvalSteps": {
          "type": "array",
          "items": {
            "type": "ApprovalStep"
          }
        }
      }
    },
    "ApprovalCriteriaOperators": {
      "type": "object",
      "properties": {
        "value": {
          "type": "integer"
        },
        "label": {
          "type": "string"
        },
        "identifier": {
          "type": "string"
        },
        "symbol": {
          "type": "string"
        }
      }
    },
    "CriteriaOperators": {
      "type": "object",
      "properties": {
        "key": {
          "type": "string"
        },
        "operators": {
          "type": "array",
          "items": {
            "type": "ApprovalCriteriaOperators"
          }
        }
      }
    },
    "ApproverGroupUserDetails": {
      "type": "object",
      "properties": {
        "id": {
          "type": "integer"
        },
        "userUUID": {
          "type": "string"
        },
        "firstName": {
          "type": "string"
        },
        "lastName": {
          "type": "string"
        },
        "email": {
          "type": "string"
        }
      }
    }
  }
}

Properties

NAME

TYPE

ATTRIBUTES

DEFAULT

DESCRIPTION

seekApprovalTemplateId

Integer

Not Required

This method returns the Template ID of Seek Approval Notification.

remindApprovalTemplateId

Integer

Not Required

This method returns the Template ID of Approval Reminder Notification.

approvalFulfilmentTemplateId

Integer

Not Required

This method returns the Tempalte ID of Approval Fulfillment Notification.

Custom Operations

OPERATION

VERB

PATH

RETURNS

Description

getApprovalRequests

GET

/request

List of ApprovalRequestAccepted

The getApprovalRequests operation is to fetch the Approval Requests. Operation accepts header param “APS-Identity-ID” and Query Param type. Method returns List of ApprovalRequestAccepted

updateRequest

PUT

/request

List of ApprovalResponseExtended

The updateRequest operation will update the Approval Request. After Approve or reject of Approval Request, this operation is invoked. Operation accepts List of ApprovalRequestContext and header param “APS-Identity-ID”.

submitForApproval

POST

/submitForApproval

ApprovalResponse

The submit operation is for accepting Approval Request from Client Application. Operation accepts RequestForApproval and returns ApprovalResponse

getApprovalStepProgress

GET

/request/progress

List of ApprovalStepProgress

The getApprovalStepProgress operation is for fetching the approval status of all Approval Steps of Approval Request. Operation accepts Query Param requestId which is Request UUID and returns List of ApprovalStepProgress.

getApprovalRequestDetails

GET

/request/{requestId}

ApprovalRequestAccepted

The getApprovalRequestDetails operation is for fetching the approval request details for a particular request. Operation accepts Path Param requestId which is Request UUID and returns ApprovalRequestAccepted object.

getRequestsDashboardInfo

GET

/request/dashboardInfo

The getRequestsDashboardInfo operation is to get collected info about the requests, available on dashboard

getWorkflowDetails

GET

/workflow

List of WorkflowDetails

The getWorkflowDetails Operation is fetching the all Approval Workflow of the system for that Account. Operation accepts Header Param “APS-Identity-ID”, is logged in user UUID. The operation returns List of WorkflowDetails

saveWorkflow

POST

/workflow

WorkflowDetails

The saveWorkflow operation is to save Approval Workflow. Operation accepts structure Workflow and Header Param “APS-Identity-ID”, is logged in user UUID.

updateWorkflow

PUT

/workflow

WorkflowDetails

The updateWorkflow operation is to update Approval Workflow. Operation accepts structure Workflow and Header Param “APS-Identity-ID”, is logged in user UUID.

getWorkflow

GET

/workflow/{workflowUUID}

Workflow

The getWorkflow operation is to fetch details of Approval Workflow. Operation accepts Path Param workflowUUID and returns Workflow

deleteWorkflow

PUT

/workflow/delete

The operation deleteWorkflow is for deleting Approval Workflow. Operation accepts List of String and returns boolean

getCriteriaOperators

GET

/workflow/criteriaoperators

List of CriteriaOperators

The getCriteriaOperators operation fetch all the criteria operators. See Operators Operation returns CriteriaOperators

getUsersByLoggedInUser

GET

/workflow/approvers

List of ApproverGroupUserDetails

The getUsersByLoggedInUser operation fetch all the staff member list of the account. Method accepts Header Param “APS-Identity-ID”, is logged in user UUID.

getApprovalRequests

HTTP Request

GET /aps/2/resources/{aps-id}/request

Description

The getApprovalRequests operation is to fetch the Approval Requests. Operation accepts header param “APS-Identity-ID” and Query Param type. Method returns List of ApprovalRequestAccepted

Parameters

PARAMETER

TYPE

DESCRIPTION

type

String

Type is of either “pending” or “processed”. Pending will fetch list of Approval Request which are Pending and Processed will fetch Approval Request of Approval Status Approved, Rejected and Aborted.

Returns

List of ApprovalRequestAccepted

updateRequest

HTTP Request

PUT /aps/2/resources/{aps-id}/request

Description

The updateRequest operation will update the Approval Request. After Approve or reject of Approval Request, this operation is invoked. Operation accepts List of ApprovalRequestContext and header param “APS-Identity-ID”.

Parameters

PARAMETER

TYPE

DESCRIPTION

request

Array

List of ApprovalRequestContext

Returns

List of ApprovalResponseExtended

submitForApproval

HTTP Request

POST /aps/2/resources/{aps-id}/submitForApproval

Description

The submit operation is for accepting Approval Request from Client Application. Operation accepts RequestForApproval and returns ApprovalResponse

Parameters

PARAMETER

TYPE

DESCRIPTION

requestForApproval

RequestForApproval

Payload structure of request for Approval. See RequestForApproval

Returns

ApprovalResponse

getApprovalStepProgress

HTTP Request

GET /aps/2/resources/{aps-id}/request/progress

Description

The getApprovalStepProgress operation is for fetching the approval status of all Approval Steps of Approval Request. Operation accepts Query Param requestId which is Request UUID and returns List of ApprovalStepProgress.

Parameters

PARAMETER

TYPE

DESCRIPTION

requestId

String

Request UUID

Returns

List of ApprovalStepProgress

getApprovalRequestDetails

HTTP Request

GET /aps/2/resources/{aps-id}/request/{requestId}

Description

The getApprovalRequestDetails operation is for fetching the approval request details for a particular request. Operation accepts Path Param requestId which is Request UUID and returns ApprovalRequestAccepted object.

Parameters

PARAMETER

TYPE

DESCRIPTION

requestId

String

Request Id

Returns

ApprovalRequestAccepted

getRequestsDashboardInfo

HTTP Request

GET /aps/2/resources/{aps-id}/request/dashboardInfo

Description

The getRequestsDashboardInfo operation is to get collected info about the requests, available on dashboard

Returns

getWorkflowDetails

HTTP Request

GET /aps/2/resources/{aps-id}/workflow

Description

The getWorkflowDetails Operation is fetching the all Approval Workflow of the system for that Account. Operation accepts Header Param “APS-Identity-ID”, is logged in user UUID. The operation returns List of WorkflowDetails

Returns

List of WorkflowDetails

saveWorkflow

HTTP Request

POST /aps/2/resources/{aps-id}/workflow

Description

The saveWorkflow operation is to save Approval Workflow. Operation accepts structure Workflow and Header Param “APS-Identity-ID”, is logged in user UUID.

Parameters

PARAMETER

TYPE

DESCRIPTION

workflow

Workflow

Structure Workflow

Returns

WorkflowDetails

updateWorkflow

HTTP Request

PUT /aps/2/resources/{aps-id}/workflow

Description

The updateWorkflow operation is to update Approval Workflow. Operation accepts structure Workflow and Header Param “APS-Identity-ID”, is logged in user UUID.

Parameters

PARAMETER

TYPE

DESCRIPTION

workflow

Workflow

Structure Workflow

Returns

WorkflowDetails

getWorkflow

HTTP Request

GET /aps/2/resources/{aps-id}/workflow/{workflowUUID}

Description

The getWorkflow operation is to fetch details of Approval Workflow. Operation accepts Path Param workflowUUID and returns Workflow

Parameters

PARAMETER

TYPE

DESCRIPTION

workflowUUID

String

WorkflowUUID of ApprovalWorkflow

Returns

Workflow

deleteWorkflow

HTTP Request

PUT /aps/2/resources/{aps-id}/workflow/delete

Description

The operation deleteWorkflow is for deleting Approval Workflow. Operation accepts List of String and returns boolean

Parameters

PARAMETER

TYPE

DESCRIPTION

workflowUUIDs

Array

List of String

Returns

getCriteriaOperators

HTTP Request

GET /aps/2/resources/{aps-id}/workflow/criteriaoperators

Description

The getCriteriaOperators operation fetch all the criteria operators. See Operators Operation returns CriteriaOperators

Returns

List of CriteriaOperators

getUsersByLoggedInUser

HTTP Request

GET /aps/2/resources/{aps-id}/workflow/approvers

Description

The getUsersByLoggedInUser operation fetch all the staff member list of the account. Method accepts Header Param “APS-Identity-ID”, is logged in user UUID.

Returns

List of ApproverGroupUserDetails

Structures

RequestProperties

This Structure contains information about Request Properties.

NAME

TYPE

ATTRIBUTES

DEFAULT

DESCRIPTION

description

String

Not Required

Description.

fields

Array of EntityProperty

Not Required

Fields.

EntityProperty

This structure contains information about Approval Request Entity Property.

NAME

TYPE

ATTRIBUTES

DEFAULT

DESCRIPTION

name

String

Not Required

Property Name

value

String

Not Required

Value.

number

Integer

Not Required

Number.

description

String

Not Required

Description.

Status

This Structure contains information about Status.

NAME

TYPE

ATTRIBUTES

DEFAULT

DESCRIPTION

state

String

Not Required

State or Status Name

statusId

Integer

Not Required

Status ID

ObjectProperty

NAME

TYPE

ATTRIBUTES

DEFAULT

DESCRIPTION

key

String

Not Required

Key.

value

String

Not Required

Value.

ApprovalStepProgress

This structure contains information about Approval Step Progress.

NAME

TYPE

ATTRIBUTES

DEFAULT

DESCRIPTION

approvalObjectId

String

Not Required

Approving Object ID

approvalObjectName

String

Not Required

Approval Object Name

stepId

Integer

Not Required

Step ID

stepStatus

String

Not Required

Approval Step Status

stepStatusId

Integer

Not Required

rank

Integer

Not Required

Execution Order

approverUserName

String

Not Required

Approvweer User Name

designatedApproverName

String

Not Required

Designated Approver names

approverUUIDs

Array of String

Not Required

reason

String

Not Required

Comment.

approvalCriteriaList

Array of ApprovalCriteria

Not Required

Approval Criteria List

creationDate

String

Not Required

lastEditDate

String

Not Required

timeOfAutoProcessing

String

Not Required

ApprovalCriteria

This structure contains information about Approval Criteria.

NAME

TYPE

ATTRIBUTES

DEFAULT

DESCRIPTION

criteriaName

String

Not Required

Criteria Name

criteriaUUID

String

Not Required

Criteria UUID

criteriaHBID

Integer

Not Required

Criteria Hibernate ID

criteriaDisplayName

String

Not Required

Criteria Display Name

dataType

String

Not Required

Criteria Data Type

operator

String

Not Required

Criteria Operator

operatorLabel

String

Not Required

Criteria Operator Label

value

String

Not Required

Criteria Value

creationDate

String

Not Required

Criteria Creation Date

lastEditDate

String

Not Required

Criteria Last Modification Date

operatorSymbol

String

Not Required

Criteria Operator Symbol

ApprovalRequestAccepted

This structure contains information about Approval Request.

NAME

TYPE

ATTRIBUTES

DEFAULT

DESCRIPTION

requestId

String

Not Required

Request UUID

requestHBID

Integer

Not Required

Request Hibernate ID

workflowId

Integer

Not Required

Approval Workflow ID

stepId

Integer

Not Required

Step ID

performingApplication

String

Not Required

Client Application of Approval Request

operationName

String

Not Required

Operation Name

parameters

Array of RequestProperties

Not Required

Request Parameters list

workflowUuid

String

Not Required

workflowDescription

String

Not Required

initiator

String

Not Required

Intiator of Approval Request

initiatorId

String

Not Required

requestDate

String

Not Required

Approval Request Date

lastEditDate

String

Not Required

Last Modification date

status

Status

Not Required

Approval Status

performBy

String

Not Required

Perform By

reason

String

Not Required

Comments.

id

String

Not Required

ID.

name

String

Not Required

Name of the Approving Object

isApprover

Boolean

Not Required

objectProperties

Array of ObjectProperty

Not Required

List of Object Property ObjectProperty

approvalStepProgress

Array of ApprovalStepProgress

Not Required

Get History of Aproval Steps ApprovalStepProgress

applicationAPSPackageId

String

Not Required

Client Application APS Package ID

ApprovalRequestContext

This structure contains information about Approval Request Context, used for Approve or Reject Approval Request.

NAME

TYPE

ATTRIBUTES

DEFAULT

DESCRIPTION

requestId

String

Not Required

Request ID

workflowId

Integer

Not Required

Workflow ID

stepId

Integer

Not Required

Step ID

UIAction

String

Not Required

UI Action

reason

String

Not Required

Comment.

performBy

String

Not Required

Perform by

RequestInitiatorType

RequestEntity

This Structure contains information about Request Entity.

NAME

TYPE

ATTRIBUTES

DEFAULT

DESCRIPTION

id

String

Not Required

ID.

name

String

Not Required

Name.

fields

Array of EntityProperty

Not Required

Fields.

RequestForApproval

This Structure contains information about Request For Approval.

NAME

TYPE

ATTRIBUTES

DEFAULT

DESCRIPTION

performingApplication

String

Not Required

Application.

moduleAPSIdentifier

String

Not Required

Client Application APS Identifier UUID

actionName

String

Not Required

Action Name

initiator

String

Not Required

Intiator.

initiatorType

Enum

Not Required

entity

RequestEntity

Not Required

Entity.

DashboardInfo

This structure contains information for dashboard plugin.

NAME

TYPE

ATTRIBUTES

DEFAULT

DESCRIPTION

numRequestsWaitingMyApprove

Integer

Not Required

timeOfNextAutohandling

String

Not Required

WorkflowDetails

This structure contains information about Approval Workflow Details.

NAME

TYPE

ATTRIBUTES

DEFAULT

DESCRIPTION

workflowUUID

String

Not Required

Workflow UUID

workflowHBID

Integer

Not Required

Workflow Hibernate ID

description

String

Not Required

Description.

applicationName

String

Not Required

Application Name

applicationAPSTypeId

String

Not Required

Application APS Type

action

String

Not Required

Action.

creationDate

String

Not Required

Creation Date

lastEditDate

String

Not Required

Last Modified Date

ownerAccountId

String

Not Required

Owner Account ID

moduleAPSIdentifier

String

Not Required

Client Application APS Identifier UUID

actionBody

ModuleAction

Not Required

Action Body

autoProcessThreshold

Integer

Not Required

Auto Abort/Approve Threshold in Hours

autoProcessAction

AutoProcessAction

Not Required

Return action that we set for the auto processed requests

initiatorType

RequestInitiatorType

Not Required

isActive

Boolean

Not Required

Is Active

applicationAPSPackageId

String

Not Required

Client Application APS Package ID

ModuleAction

This structure contains information about Module Action.

NAME

TYPE

ATTRIBUTES

DEFAULT

DESCRIPTION

name

String

Not Required

Name.

entity

ModuleActionEntity

Not Required

Module Action Entity

ModuleActionEntity

This structure contains information about Module Action Entity.

NAME

TYPE

ATTRIBUTES

DEFAULT

DESCRIPTION

fields

Array of TypedProperty

Not Required

Fields.

TypedProperty

This Structure contains information about Typed Properties.

NAME

TYPE

ATTRIBUTES

DEFAULT

DESCRIPTION

name

String

Not Required

Name.

value

String

Not Required

Value.

displayName

String

Not Required

Display Name

displayHint

String

Not Required

Display Hint

type

String

Not Required

Type.

isArray

Boolean

Not Required

isCriteria

Boolean

Not Required

AutoProcessAction

ApprovalStep

This structure contains information about Approval Step.

NAME

TYPE

ATTRIBUTES

DEFAULT

DESCRIPTION

stepUUID

String

Not Required

Step UUID

stepHBID

Integer

Not Required

Step Hibernate ID

approvalCriteriaList

Array of ApprovalCriteria

Not Required

Criteria List

approverUserUUID

String

Not Required

Step Approver User UUID

approverUserName

String

Not Required

Step Approver User Name

approverAccountUUID

String

Not Required

Step Approver Account UUID

creationDate

String

Not Required

Step Creation Date

lastEditDate

String

Not Required

Step Last Modification Date

rank

Integer

Not Required

Step Execution Order

Workflow

This structure contains information about Approval Workflow.

NAME

TYPE

ATTRIBUTES

DEFAULT

DESCRIPTION

workflowDetails

WorkflowDetails

Not Required

Workflow Details

approvalSteps

Array of ApprovalStep

Not Required

Approval Steps

ApprovalCriteriaOperators

This structure contains information about Approval Criteria Operator.

NAME

TYPE

ATTRIBUTES

DEFAULT

DESCRIPTION

value

Integer

Not Required

Value of the Operator

label

String

Not Required

Label.

identifier

String

Not Required

Identifier.

symbol

String

Not Required

Symbol.

CriteriaOperators

This structure contains information about Criteria Operators.

NAME

TYPE

ATTRIBUTES

DEFAULT

DESCRIPTION

key

String

Not Required

operators

Array of ApprovalCriteriaOperators

Not Required

ApproverGroupUserDetails

This structure contains information about Details of User who is staff member and going to be Approver as well.

NAME

TYPE

ATTRIBUTES

DEFAULT

DESCRIPTION

id

Integer

Not Required

ID.

userUUID

String

Not Required

User UUID

firstName

String

Not Required

First Name

lastName

String

Not Required

Last Name

email

String

Not Required

Email.

Examples

Please find general description of create-read-update-delete (CRUD) operations with resources, properties, and structures respectively at:

Since the considered APS type contains custom operations, refer to Custom Operations for the general explanation of their structure and examples of operation calls.